#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstring>

using namespace std;

class GogoXBallsAndBins {
public:
	static int solve(vector <int>, int);
};

const int maxS = 50 * 50 * 6;
const int shiftS = maxS / 2;
const int maxN = 52;
const int P = 1000000009;
long long d[2][maxN][maxS];

int GogoXBallsAndBins::solve(vector <int> T, int moves) {
	int u = 0, v = 1, n = T.size();
	memset(d[u], 0, sizeof(d[u]));
	d[u][0][shiftS + 0] = 1;
	for (int step = 0; step < n; ++step, swap(u, v)) {
		memset(d[v], 0, sizeof(d[v]));
		for (int i = 0; i <= step; ++i) {
			for (int score = 0; score < maxS; ++score) {
				if (d[u][i][score] == 0) {
					continue;
				}

				d[v][i][score] += d[u][i][score];
				d[v][i][score] %= P;

				d[v][i + 1][score - 2 * T[step]] += d[u][i][score];
				d[v][i + 1][score - 2 * T[step]] %= P;

				if (i > 0) {
					d[v][i][score] += 2LL * d[u][i][score] * (long long)(i);
					d[v][i][score] %= P;

					d[v][i - 1][score + T[step] * 2] += d[u][i][score] * (long long)(i * i);
					d[v][i - 1][score + T[step] * 2] %= P;
				}
			}
		}
	}

	return d[u][0][shiftS + 2 * moves];
}

int main() {
	int n, m;
	cin >> n >> m;
	vector < int > a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	cout << GogoXBallsAndBins::solve(a, m) << endl;
	
	return 0;
}