#include <string.h>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>

using namespace std;

class BinaryCodes {
public:
	static int ambiguous(vector <string>);
};

#define state pair < int, pair < int, pair < int, pair < int, int > > > >
#define mp(a, b, c, d, e) make_pair(a, make_pair(b, make_pair(c, make_pair(d, e))))

#define _a first
#define _b second.first
#define _c second.second.first
#define _d second.second.second.first
#define _e second.second.second.second

int n;
int d[60][60][60][3];
set < state > S;
vector < string > code;

bool check(string s1, string s2)
{
	for (int i = 0; i < s2.size(); i ++)
		if (s1[i] != s2[i]) return false;
	return true;
}

bool add(string s1, int l, string s2)
{
	for (int i = s1.size() - l; i < s1.size() && i < s1.size() - l + s2.size(); i ++)
		if (s1[i] != s2[i - s1.size() + l]) return false;
	return true;
}

void update(int len, int cur, int l1, int l2, int mode)
{
	if (mode != 2)
	{
		for (int i = 0; i < n; i ++)
			if (add(code[cur], l2, code[i]))
			{
				int nlen = max(len, len - l2 + (int)(code[i].size()));
				int ncur = (len >= len - l2 + code[i].size() ? cur : i);
				int nl1 = nlen - len + l1;
				int nl2 = (len >= len - l2 + code[i].size() ? l2 - code[i].size() : nlen - len);
				int nmode = (len >= len - l2 + code[i].size() ? mode : (mode == 0 ? 0 : 2));

				if (nl1 > nl2) swap(nl1, nl2);
				if (d[ncur][nl1][nl2][nmode] > nlen)
				{
					S.erase(mp(d[ncur][nl1][nl2][nmode], ncur, nl1, nl2, nmode));
					d[ncur][nl1][nl2][nmode] = nlen;
					S.insert(mp(nlen, ncur, nl1, nl2, nmode));
				}
			}
	} else
	{
		for (int i = 0; i < n; i ++)
			if (add(code[cur], l2, code[i]))
			{
				int nlen = max(len, len - l2 + (int)code[i].size());
				int ncur = (len >= len - l2 + code[i].size() ? cur : i);
				int nl1 = nlen - len + l1 - code[i].size();
				int nl2 = nl1;
				int nmode = (nlen > len ? 1 : 2);
				if (nlen > len) nl1 = nlen - len, nl2 = 0;
				if (nl1 > nl2) swap(nl1, nl2);

				if (d[ncur][nl1][nl2][nmode] > nlen)
				{
					S.erase(mp(d[ncur][nl1][nl2][nmode], ncur, nl1, nl2, nmode));
					d[ncur][nl1][nl2][nmode] = nlen;
					S.insert(mp(nlen, ncur, nl1, nl2, nmode));
				}
			}
		for (int i = 0; i < n; i ++)
			if (add(code[cur], l1, code[i]))
				for (int j = 0; j < n; j ++)
					if (i != j && code[i].size() >= code[j].size() && add(code[cur], l2, code[j]) && check(code[i], code[j]))
					{
						int nlen = max(len, len - l1 + (int)code[i].size());
						int ncur = len >= len - l1 + code[i].size() ? cur : i;
						int nl1 = nlen - len + l1 - code[i].size();
						int nl2 = nlen - len + l2 - code[j].size();
						int nmode = 0;
						if (len < len - l1 + code[i].size()) nl1 = nlen - len;
						if (nl1 > nl2) swap(nl1, nl2);
						if (d[ncur][nl1][nl2][nmode] > nlen)
						{
							S.erase(mp(d[ncur][nl1][nl2][nmode], ncur, nl1, nl2, nmode));
							d[ncur][nl1][nl2][nmode] = nlen;
							S.insert(mp(nlen, ncur, nl1, nl2, nmode));
						}
					}
	}
}

int BinaryCodes::ambiguous(vector <string> code) {
	::code = code;
	n = code.size();
	S.clear();
	int mx = 0;
	for (int i = 0; i < n; i ++)
		mx = max(mx, (int)code[i].size());
	for (int i = 0; i < n; i ++)
		if (code[i] == "") return 0;
	for (int i = 0; i < n; i ++)
		for (int j = 0; j <= mx; j ++)
			for (int k = 0; k <= mx; k ++)
				for (int l = 0; l < 3; l ++)
					d[i][j][k][l] = 1000000000;

	for (int i = 0; i < n; i ++)
		for (int j = 0; j < n; j ++)
			if (i != j && code[i].size() >= code[j].size() && check(code[i], code[j]))
				d[i][code[i].size() - code[j].size()][code[i].size() - code[j].size()][2] = code[i].size(),
				d[i][0][code[i].size() - code[j].size()][1] = code[i].size();

	for (int i = 0; i < n; i ++)
		for (int j = 0; j < n; j ++)
			for (int k = 0; k < n; k ++)
				if (i != j && i != k && j != k)
					if (code[i].size() >= code[j].size() && code[j].size() >= code[k].size() && 
						check(code[i], code[j]) && check(code[j], code[k]))
						d[i][code[i].size() - code[j].size()][code[i].size() - code[k].size()][0] = code[i].size();

	for (int i = 0; i < n; i ++)
		for (int j = 0; j <= mx; j ++)
			for (int k = 0; k <= mx; k ++)
				for (int l = 0; l < 3; l ++)
					S.insert(mp(d[i][j][k][l], i, j, k, l));

	while (!S.empty())
	{
		state A = *S.begin(); S.erase(S.begin());
		if (A._a == 1000000000) break;
		if (A._c == 0 && A._d == 0 && A._e == 0) break;
		update(A._a, A._b, A._c, A._d, A._e);
	}

	int res = 1000000000;
	for (int i = 0; i < n; i ++)
		res = min(res, d[i][0][0][0]);
	if (res == 1000000000) res = -1;
	return res;
}

int main() {
	int n;
	cin >> n;
	vector < string > s(n);
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	cout << BinaryCodes::ambiguous(s) << endl;

	return 0;
}