#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>

using namespace std;

class BunnySequence {
public:
	static int getNumber(int, int);
};

const long long P = 1000000009;
const int maxN = 1100000;
long long d[maxN], s[maxN];

int BunnySequence::getNumber(int m, int n) {
	d[2] = 1LL;
	s[2] = 1LL;
	for (int i = 3; i <= n; ++i) {
		d[i] = s[i - 1] - (i - m - 1 >= 0 ? s[i - m - 1] : 0);
		d[i] %= P;
		if (d[i] < 0) {
			d[i] += P;
		}
		if (i <= m) {
			d[i] = (d[i] + 1) % P;
		}
		s[i] = s[i - 1] + d[i];
		s[i] %= P;
	}

	long long res = ((s[n] + 1) - (n >= m ? (s[n - m] + 1) : 0)) % P;
	res = (res + P) % P;
	return res;
}

int main() {
	int n, m;
	cin >> n >> m;
	cout << BunnySequence::getNumber(n, m) << endl;

	return 0;
}