#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>

using namespace std;

class MountainMap {
public:
	static int count(vector <string>);
};

int MD = 12345678;

int n, m;
vector < string > data;
vector < int > g[50];
vector < int > f[50];

int dx[] = {-1,-1,-1, 0, 0, 1, 1, 1};
int dy[] = {-1, 0, 1,-1, 1,-1, 0, 1};
int res = 0;
bool val(int x, int y) {return 0 <= x && x < n && 0 <= y && y < m;}

int d[30][1 << 8];
int b[30], bb[30], bits, start, glob;

int calc(int k, int mask)
{
	if (d[k][mask] != -1) return d[k][mask];
	if (k == n * m)
		return d[k][mask] = ((mask + 1 == (1 << bits)) ? 1 : 0);

	int res = 0;
	int have = bits;
	for (int i = 0; i < bits; i ++)
		if (!(mask & (1 << i))) have --, res += calc(k + 1, mask + (1 << i)), res %= MD;

	have = k - have;
	int cur = 0;
	for (int i = 0; i < n * m; i ++)
		if (!(glob & (1 << i)))
		{
			bool good = true;
			for (int j = 0; j < f[i].size(); j ++)
				if (!(mask & (1 << f[i][j]))) {good = false; break;}
			if (good) cur ++;
		}
	cur -= have;

	long long h = (long long)calc(k + 1, mask) * (long long)(cur);
	h %= (long long)MD;
	res += h, res %= MD;
	d[k][mask] = res;
	return res;
}

int solve(int mask)
{
	glob = mask;
	bits = 0;
	for (int i = 0; i < n * m; i ++)
		if (mask & (1 << i)) b[bits ++] = i, bb[i] = bits - 1;
	for (int i = 0; i < n * m; i ++)
		f[i].clear();
	for (int i = 0; i < n; i ++)
		for (int j = 0; j < m; j ++)
		{
			int v = i * m + j;
			if (!(mask & (1 << v)))
				for (int k = 0; k < 8; k ++)
					if (val(i + dx[k], j + dy[k]))
					{
						int u = (i + dx[k]) * m + j + dy[k];
						if ((mask & (1 << u)))
							f[v].push_back(bb[u]);
					}
		}
	
	for (int i = 0; i <= n * m; i ++)
		for (int j = 0; j < (1 << bits); j ++)
			d[i][j] = -1;
	int res = calc(0, 0);
	if ((bits - start) % 2 == 1) res = (MD - res) % MD;
	return res;
}

int a[50];

bool check()
{
	for (int i = 0; i < n * m; i ++)
		if (a[i] == 1)
			for (int j = 0; j < g[i].size(); j ++)
				if (a[g[i][j]] == 1) return false;
	return true;
}

void gen(int have, int cur)
{
	if (have == n * m) {res += solve(cur); res %= MD; return ;}
	if (data[have / m][have % m] == 'X') 
	{
		a[have] = 1;
		if (check()) gen(have + 1, cur + (1 << have));
		a[have] = 0;
	} else
	{
		a[have] = 1;
		if (check()) gen(have + 1, cur + (1 << have));
		a[have] = 0;
		if (check()) gen(have + 1, cur);
	}
}

int MountainMap::count(vector <string> data) {
	n = data.size(), m = data[0].size();
	::data = data;
	res = 0;
	for (int i = 0; i < n; i ++)
		for (int j = 0; j < m; j ++)
			for (int k = 0; k < 8; k ++)
				if (val(i + dx[k], j + dy[k]))
					g[i * m + j].push_back((i + dx[k]) * m + (j + dy[k]));
	start = 0;
	for (int i = 0; i < n; i ++)
		for (int j = 0; j < m; j ++)
			if (data[i][j] == 'X') start ++;
	if (start == 0) return 0;
	gen(0, 0);
	return res;
}

int main() {
	int n, m;
	cin >> n >> m;
	vector < string > s(n);
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	cout << MountainMap::count(s) << endl;
	return 0;
}