#include <string>
#include <vector>
#include <map>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <set>
#include <iostream>
#include <sstream>
#include <cstddef>
#include <algorithm>
#include <utility>
#include <iterator>
#include <numeric>
#include <list>
 
using namespace std;
 
typedef vector<int> vi;
typedef vector<int>::iterator vi_i;
typedef vector<string> vs;
typedef vector<string>::iterator vs_i;
typedef pair<int, int> pii;
 
template<class T>
void splitstr(const string &s, vector<T> &out)
{
    istringstream in(s);
    T tmp;
 
    out.clear();
    while (in >> tmp) out.push_back(tmp);
}
 
class Wardrobe
{
public:
    static int countUnscrewedHoles(vector <int> bolts);
};
 
struct dps
{
    int dp[55][55][2];
};
 
int Wardrobe::countUnscrewedHoles(vector <int> bolts)
{
    int B = bolts.size();
    int freq[110] = {0};
 
    for (int i = 0; i < B; i++)
        freq[bolts[i]]++;
 
    dps *dp[2];
    dp[0] = new dps;
    dp[1] = new dps;
    memset(&dp[0]->dp, 127, sizeof(dp[0]->dp));
    memset(&dp[1]->dp, 127, sizeof(dp[1]->dp));
    dp[0]->dp[0][0][0] = 0;
    dp[0]->dp[0][0][1] = 0;
    dp[0]->dp[0][0][2] = 0;
 
    for (int i = 100; i >= 0; i--)
    {
        for (int b = 0; b <= freq[i]; b++)
            for (int h = 0; h <= freq[i]; h++)
            {
                int (&cur)[2] = dp[1]->dp[b][h];
                cur[0] = cur[1] = 0x7f7f7f7f;
 
                if (b && h)
                {
                    cur[0] = dp[1]->dp[b - 1][h - 1][0] + 1;
                    cur[1] = dp[1]->dp[b - 1][h - 1][1] + 1;
                }
                if (b <= freq[i + 1])
                {
					cur[0] = min(cur[0], dp[0]->dp[freq[i + 1]][freq[i + 1] - b][0] + b);
                    if (!h)
						cur[0] = min(cur[0], dp[0]->dp[freq[i + 1]][freq[i + 1] - b][1] + b);
                }
                if (h <= freq[i + 1])
                {
                    cur[1] = min(cur[1], dp[0]->dp[freq[i + 1] - h][freq[i + 1]][1] + h);
                    if (!b)
                        cur[1] = min(cur[1], dp[0]->dp[freq[i + 1] - h][freq[i + 1]][0] + h);
                }
            }
        swap(dp[0], dp[1]);
    }
    return B - min(dp[0]->dp[0][0][0], dp[0]->dp[0][0][1]);
}

int main() {
	int n;
	cin >> n;
	vector < int > a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	cout << Wardrobe::countUnscrewedHoles(a) << endl;

	return 0;
}