#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

const int mod = 1234567891;
struct num {
	ll x;
	num():x(0) {}
	num(ll x):x(x) {}
	num operator+(const num& o) {
		num res(x+o.x);
		if (res.x >= mod) res.x -= mod;
		return res;
	}
	num operator-(const num& o) {
		num res(x-o.x);
		if (res.x < 0) res.x += mod;
		return res;
	}
	num operator*(const num& o) const {
		return num(x*(ll)o.x%mod);
	}
	num pow(ll n) const {
		num res(1);
		num t = *this;
		while (n) {
			if (n&1) res = res * t;
			t = t * t;
			n >>= 1;
		}
		return res;
	}
};

const int maxn = 100010;
num fact[maxn];
num revfact[maxn];

num comb(ll n, int k) {
	if (n < k) return num(0);
	num res = revfact[k];
	forn(ii, k) {
		res = res * num((n-ii)%mod);
	}
	return res;
}

num calc4(ll N, vector<int> v) {
	ll cnt = N*N;
	if (N&1) {
		--cnt;
		int cc = 0;
		forn(i, sz(v)) {
			if (v[i]&1) ++cc, v[i]--;
		}
		if (cc != 1) return num(0);
	}
	forn(i, sz(v)) if (v[i]%4) return num(0);
	forn(i, sz(v)) v[i] /= 4;
	cnt /= 4;
	ll rem = cnt;
	num res(1);
	forn(ii, sz(v)) {
		int cur = v[ii];
		res = res * comb(rem, cur);
		rem -= cur;
		if (rem < 0) return num(0);
	}
	return res;
}

num calc2(ll N, vector<int> v) {
	ll cnt = N*N;
	if (N&1) {
		--cnt;
		int cc = 0;
		forn(i, sz(v)) {
			if (v[i]&1) ++cc, v[i]--;
		}
		if (cc != 1) return num(0);
	}
	forn(i, sz(v)) if (v[i]%2) return num(0);
	forn(i, sz(v)) v[i] /= 2;
	cnt /= 2;
	ll rem = cnt;
	num res(1);
	forn(ii, sz(v)) {
		int cur = v[ii];
		res = res * comb(rem, cur);
		rem -= cur;
	}
	return res;
}

num calc1(ll N, vector<int> v) {
	ll cnt = N*N;
	num ans(0);
	ll rem = cnt;
	num res(1);
	forn(ii, sz(v)) {
		int cur = v[ii];
		res = res * comb(rem, cur);
		rem -= cur;
	}
	return res;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	fact[0] = num(1);
	for (int i = 1; i < maxn; ++i) fact[i] = fact[i-1] * num(i);
	forn(i, maxn) revfact[i] = fact[i].pow(mod-2);

	int n, m; scanf("%d%d", &n, &m);
	vector<int> a(m);
	forn(i, m) scanf("%d", &a[i]);
	num ans1 = calc1(n, a);
	num ans2 = calc2(n, a);
	num ans4 = calc4(n, a);
	num res = ans1+ans2+ans4*num(2);
	res = res * num(4).pow(mod-2);
	cout << res.x % mod << "\n";
	return 0;
}
