#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

const int mod = 1000000009;
struct num {
	ll x;
	num():x(0) {}
	num(ll x):x(x) {}
	num operator+(const num& o) {
		num res(x+o.x);
		if (res.x >= mod) res.x -= mod;
		return res;
	}
	num operator-(const num& o) {
		num res(x-o.x);
		if (res.x < 0) res.x += mod;
		return res;
	}
	num operator*(const num& o) const {
		return num(x*(ll)o.x%mod);
	}
	num pow(ll n) const {
		num res(1);
		num t = *this;
		while (n) {
			if (n&1) res = res * t;
			t = t * t;
			n >>= 1;
		}
		return res;
	}
};

const int maxn = 3000010;
num fact[maxn];
num revfact[maxn];

num comb(int n, int k) {
	if (n < k) return num(0);
	num res = fact[n] * revfact[k] * revfact[n-k];
	return res;
}

num dp[maxn];
num psum[maxn];

int calcstupid(int m, int x) {
	int ans = 0;
	while (x != 1) {
		if (x % m) ++x;
		else x /= m;
		ans++;
	}
	return ans;
}

const int MAGIC = 1000000;

int stupid(int m, int n) {
	int res = 0;
	for(int i = 1; i < MAGIC; ++i) res += calcstupid(m, i) == n;
	return res;
}

num solve(int m, int n) {
	dp[0] = num(1);
	psum[0] = num(1);
	for (int i = 1; i <= n; ++i) {
		int fr = i-m;
		int to = i-1;
		dp[i] = psum[to];
		if (i == m) fr = max(1,fr);
		if (fr-1 >= 0) dp[i] = dp[i] - psum[fr-1];
		psum[i] = dp[i]+psum[i-1];
	}
	num ans = dp[n];
	return ans;
}

void stress() {
	for (int m = 2; m <= 5; ++m) for (int n = 0; n <= 5; ++n) {
		cerr << m << " " << n << "\n";
		int r1 = stupid(m,n);
		int r2 = solve(m,n).x;
		if (r1 != r2) {
			printf("FAIL\n");
			exit(0);
		}
	}
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	//stress();
	//return 0;
	/*fact[0] = num(1);
	for (int i = 1; i < maxn; ++i) fact[i] = fact[i-1] * num(i);
	forn(i, maxn) revfact[i] = fact[i].pow(mod-2);*/
	int m, n; scanf("%d%d", &m, &n);
	num ans = solve(m, n);
	cout << ans.x << "\n";

	/*if (n == 0) printf("1\n"), exit(0);
	num ans(0);
	for (int i = 1; i <= n; ++i) {
		int rem = n-i;
		if (rem < 0) break;
		num mult(1);
		for (int j = 0; j <= i; ++j) {
			ll rr = rem - j*(ll)m;
			if (rr < 0) break;
			int rempos = i-j;
			num curadd = comb(rr+rempos-1,rr);
			curadd = curadd * comb(i, j);
			curadd = curadd * mult;
			ans = ans + curadd;
			mult = num(0)-mult;
		}
	}
	cout << ans.x << "\n";*/
	return 0;
}
