import java.io.*;
import java.util.*;
import java.math.*;

public class D implements Runnable {
	private static BufferedReader in;
	private static StringTokenizer st;
	private static PrintWriter out;

	static class Triple {
		int a, b, c;

		public Triple(int a, int b, int c) {
			this.a = a;
			this.b = b;
			this.c = c;
		}

	}

	final int numberStates = 3;
	final int none = -1, free = 0, taken = 1, must = 2;

	private void solve() throws IOException {
		int numbersCount = nextInt();
		int[] numbers = new int[numbersCount];
		for (int i = 0; i < numbersCount; i++) {
			numbers[i] = nextInt();
		}
		Arrays.sort(numbers);

		int[][][][] d = new int[numbersCount][numberStates][numberStates][numberStates];
		for (int i = 0; i < numbersCount; i++) {
			for (int a = 0; a < numberStates; a++) {
				for (int b = 0; b < numberStates; b++) {
					for (int c = 0; c < numberStates; c++) {
						d[i][a][b][c] = none;
					}
				}
			}
		}

		d[0][taken][taken][free] = 0;
		if (numbersCount > 0 && numbers[0] + 1 == numbers[1])
			d[0][taken][free][taken] = 0;
		d[0][taken][must][must] = 1;

		for (int i = 0; i < numbersCount - 1; i++) {
			for (int a = 0; a < numberStates; a++) {
				for (int b = 0; b < numberStates; b++) {
					for (int c = 0; c < numberStates; c++) {
						int currentValue = d[i][a][b][c];
						if (currentValue != none) {
							// out.println(i + " " + a + " " + b + " " + c + " "
							// + currentValue);

							int lastAValue = numbers[i] - 1;
							int lastBValue = numbers[i];
							int lastCValue = numbers[i] + 1;

							int newAValue = numbers[i + 1] - 1;
							int newBValue = numbers[i + 1];
							int newCValue = numbers[i + 1] + 1;

							// set in a
							if (weHave(numbers, newAValue)) {
								// out.println("Get A");
								Triple newStates = getAStates(new Triple(
										lastAValue, lastBValue, lastCValue),
										new Triple(newAValue, newBValue,
												newCValue), new Triple(a, b, c));
								if (newStates != null) {
									// out.println("Go A: " + newStates.a + " "
									// + newStates.b + " " + newStates.c);
									d[i + 1][newStates.a][newStates.b][newStates.c] = Math
											.max(d[i + 1][newStates.a][newStates.b][newStates.c],
													currentValue);
								}
							}

							// set in b
							if (weHave(numbers, newBValue)) {
								Triple newStates = getBStates(new Triple(
										lastAValue, lastBValue, lastCValue),
										new Triple(newAValue, newBValue,
												newCValue), new Triple(a, b, c));
								if (newStates != null) {
									d[i + 1][newStates.a][newStates.b][newStates.c] = Math
											.max(d[i + 1][newStates.a][newStates.b][newStates.c],
													currentValue);
								}
							}

							// set in c
							if (weHave(numbers, newCValue)) {
								Triple newStates = getCStates(new Triple(
										lastAValue, lastBValue, lastCValue),
										new Triple(newAValue, newBValue,
												newCValue), new Triple(a, b, c));
								if (newStates != null) {
									d[i + 1][newStates.a][newStates.b][newStates.c] = Math
											.max(d[i + 1][newStates.a][newStates.b][newStates.c],
													currentValue);
								}
							}

							// skip
							{
								Triple newStates = getSkipStates(new Triple(
										lastAValue, lastBValue, lastCValue),
										new Triple(newAValue, newBValue,
												newCValue), new Triple(a, b, c));
								if (newStates != null) {
									d[i + 1][newStates.a][newStates.b][newStates.c] = Math
											.max(d[i + 1][newStates.a][newStates.b][newStates.c],
													currentValue + 1);
								}
							}
						}
					}
				}
			}
		}

		int result = none;
		for (int a = 0; a < numberStates; a++) {
			for (int b = 0; b < numberStates; b++) {
				for (int c = 0; c < numberStates; c++) {
					if (a != must && b != must && c != must) {
						/*
						 * if (d[numbersCount - 1][a][b][c] == 2) {
						 * out.println(a + " " + b + " " + c); }
						 */
						result = Math.max(result, d[numbersCount - 1][a][b][c]);
					}
				}
			}
		}
		out.println(result);

	}

	private boolean weHave(int[] numbers, int value) {
		return Arrays.binarySearch(numbers, value) >= 0;
	}

	private Triple getAStates(Triple oldValues, Triple newValues,
			Triple oldStates) {
		if (oldValues.a == newValues.a) {
			if (oldStates.a == taken || oldStates.b == must)
				return null;
			oldStates.a = taken;
			oldStates.b = free;
			return oldStates;
		} else if (oldValues.a + 1 == newValues.a) {
			if (oldStates.a == must || oldStates.b == taken)
				return null;
			return new Triple(taken, oldStates.c, free);
		} else if (oldValues.a + 2 == newValues.a) {
			if (oldStates.a == must || oldStates.b == must
					|| oldStates.c == taken)
				return null;
			return new Triple(taken, free, free);
		} else {
			if (oldStates.a == must || oldStates.b == must
					|| oldStates.c == must)
				return null;
			return new Triple(taken, free, free);
		}
	}

	private Triple getBStates(Triple oldValues, Triple newValues,
			Triple oldStates) {
		if (oldValues.a == newValues.a) {
			oldStates.b = (oldStates.b == free ? free : taken);
			return oldStates;
		} else if (oldValues.a + 1 == newValues.a) {
			if (oldStates.a == must || oldStates.c == taken)
				return null;
			return new Triple(oldStates.b, taken, free);
		} else if (oldValues.a + 2 == newValues.a) {
			if (oldStates.a == must || oldStates.b == must)
				return null;
			return new Triple(oldStates.c, taken, free);
		} else {
			if (oldStates.a == must || oldStates.b == must
					|| oldStates.c == must)
				return null;
			return new Triple(free, taken, free);
		}
	}

	private Triple getCStates(Triple oldValues, Triple newValues,
			Triple oldStates) {
		if (oldValues.a == newValues.a) {
			if (oldStates.c == taken || oldStates.b == must)
				return null;
			oldStates.b = free;
			oldStates.c = taken;
			return oldStates;
		} else if (oldValues.a + 1 == newValues.a) {
			if (oldStates.a == must)
				return null;
			return new Triple(oldStates.b, oldStates.c, taken);
		} else if (oldValues.a + 2 == newValues.a) {
			if (oldStates.a == must || oldStates.b == must)
				return null;
			return new Triple(oldStates.c, free, taken);
		} else {
			if (oldStates.a == must || oldStates.b == must
					|| oldStates.c == must)
				return null;
			return new Triple(free, free, taken);
		}
	}

	private int mustMerge(int state) {
		return (state == taken ? taken : must);
	}

	private Triple getSkipStates(Triple oldValues, Triple newValues,
			Triple oldStates) {
		if (oldValues.a == newValues.a) {
			if (oldStates.b == must)
				return null;
			return new Triple(mustMerge(oldStates.a), mustMerge(oldStates.b),
					mustMerge(oldStates.c));
		} else if (oldValues.a + 1 == newValues.a) {
			if (oldStates.a == must)
				return null;
			return new Triple(mustMerge(oldStates.b), mustMerge(oldStates.c),
					must);
		} else if (oldValues.a + 2 == newValues.a) {
			if (oldStates.a == must || oldStates.b == must)
				return null;
			return new Triple(mustMerge(oldStates.c), must, must);
		} else {
			if (oldStates.a == must || oldStates.b == must
					|| oldStates.c == must)
				return null;
			return new Triple(must, must, must);
		}
	}

	public void run() {
		try {
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new D().run();
	}

	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	private long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	private double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

}
