import java.io.*;
import java.util.*;
import java.math.*;

public class F implements Runnable {
	private static BufferedReader in;
	private static StringTokenizer st;
	private static PrintWriter out;

	private void solve() throws IOException {
		int m = nextInt(), n = nextInt();
		out.println(solveSmart(m, n));
		//out.println(solveDumb(m, n));
	}

	private int solveSmart(int m, int n) {

		final int MODULO = 1000000000 + 9;

		int[][] changes = new int[6][n + 1];
		int[][] dynamic = new int[6][n + 1];
		int[] currentAdds = new int[6];
		dynamic[0][0] = 1;

		for (int i = 0; i <= n; i++) {
			for (int k = 0; k <= 2; k++) {
				for (int decreasing = 0; decreasing <= 1; decreasing++) {
					int state = 3 * decreasing + k;
					currentAdds[state] += changes[state][i];
					if (currentAdds[state] >= MODULO)
						currentAdds[state] -= MODULO;
					dynamic[state][i] += currentAdds[state];
					if (dynamic[state][i] >= MODULO)
						dynamic[state][i] -= MODULO;

					// out.println("WTF: " + i + " " + state + " "
					// + dynamic[state][i] + " " + changes[state][i]);

					int current = dynamic[state][i];
					if (i < n && current != 0) {

						// multiply
						{
							int newK = Math.min(2, k + 1);
							int newState = newK;
							dynamic[newState][i + 1] += current;
							if (dynamic[newState][i + 1] >= MODULO)
								dynamic[newState][i + 1] -= MODULO;
						}

						// decrease
						if (k == 1 && m > 2 && decreasing == 0) {
							int length = m - 2;
							int newState = 3 + k;
							changes[newState][i + 1] += current;
							if (changes[newState][i + 1] >= MODULO)
								changes[newState][i + 1] -= MODULO;
							if (i + length + 1 <= n) {
								changes[newState][i + length + 1] -= current;
								if (changes[newState][i + length + 1] < 0)
									changes[newState][i + length + 1] += MODULO;
							}
						}
						if (k == 2 && decreasing == 0) {
							int length = m - 1;
							int newState = 3 + k;
							changes[newState][i + 1] += current;
							if (changes[newState][i + 1] >= MODULO)
								changes[newState][i + 1] -= MODULO;
							if (i + length + 1 <= n) {
								changes[newState][i + length + 1] -= current;
								if (changes[newState][i + length + 1] < 0)
									changes[newState][i + length + 1] += MODULO;
							}
						}
					}
				}
			}
		}
		long result = 0;
		for (int i = 0; i < 6; i++)
			result += dynamic[i][n];
		result %= MODULO;
		return (int) result;
	}

	private int solveDumb(int m, int n) {
		final int buben = 10000000;
		int resultCount = 0;
		for (int x = 1; x <= buben; x++) {
			int[] result = new int[n + 1];
			result[0] = x;
			for (int i = 1; i <= n; i++) {
				int a = result[i - 1];
				if (a % m == 0)
					result[i] = a / m;
				else
					result[i] = a + 1;
			}
			int targetIndex = 0;
			while (targetIndex <= n && result[targetIndex] != 1) {
				++targetIndex;
			}
			if (targetIndex == n) {
				//out.println(Arrays.toString(result));
				++resultCount;
			}
		}
		return resultCount;
	}

	public void run() {
		try {
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new F().run();
	}

	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	private long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	private double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

}
