#pragma comment(linker , "/STACK:128000000")

#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int n, m;
char table[4][7];


struct state {
	int last[5];
	bool isX[5];
	int x, y;
	
	int val;

	bool operator < (const state& oth) const {
		if (mp(x, y) != mp(oth.x, oth.y)) {
			return mp(x, y) < mp(oth.x, oth.y);
		}
		for (int i = 0; i < 5; ++i) {
			if (mp(last[i], isX[i]) != mp(oth.last[i], oth.isX[i])) {
				return mp(last[i], isX[i]) < mp(oth.last[i], oth.isX[i]);
			}	
		}
		return false;
	}

	state(){}
	state(int xx, int yy, int val, int* last0, bool* isX0):x(xx),y(yy), val(val) {
		++x;
		if (x == n) {
			x = 0;
			++y;
		}

		for (int i = 0; i < 5; ++i) {
			last[i] = last0[i];
			isX[i] = isX0[i];
		}
		//last[4] = newlast;

		//isX[4] = (newlast < last[0] && newlast < last[3] && newlast < last0[0]);

	}

	void go(int id);	
};

priority_queue <state> q[2];

void state::go(int id) {
	
	int newlast[5];
	bool newisX[5];

	int diap = n * m - (y * n + x);
	diap = min(diap + n + 1, n * m);

	for (int i = 0; i < diap; ++i) {
		for (int i = 0; i < n; ++i) {
			newlast[i] = last[i + 1];
			newisX[i] = isX[i + 1];
		}
		bool f = true;
		for (int j = 0; j <= n; ++j) {
			if (last[j] == i) {
				f = false;
				break;
			}
		}

		if (!f) {
			continue;
		}

		newlast[n] = i;
		newisX[n] = (i < newlast[0]);
		if (x > 0) {
			newisX[n] &= i < last[0];
			newisX[n] &= i < newlast[n - 1];
			newisX[n - 1] &= (newlast[n - 1] < newlast[n]);
		}

		if(x < n - 1) {
			newisX[n] &= i < last[1];
			newisX[1] &= last[1] < i;
		}
		
		newisX[0] &= i < newlast[0];
		
		bool isX0 = isX[0];
		if (x > 0) {
			isX0 &= last[0] < i;
		}
		

		int prevX = x - 1;
		if (prevX < 0)
			prevX += n;
		int prevY = y - 1 - (x == 0);
		if (prevY >= 0) {
			if (table[prevX][prevY] != isX0)
				continue;
		}

		for (int j = 0; j <= n; ++j) {
			if (newlast[j] > last[0]) {
				--newlast[j];
			}
		}

		q[id].push(state(x, y, val, newlast, newisX));
	}
}

const int mod = 12345678;

void solve() {
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> table[i][j];
			table[i][j] = (table[i][j] == 'X');
		}
	}

	int last[5];
	bool isX[5];
	for (int i = 0; i <= n; ++i) {
		last[i] = 100000;
		isX[i] = false;
	}

	q[0].push(state(0, 0, 1, last, isX));
	int cur = 0;

	int ans = 0;

	while (true) {
		//cerr << "!!" << endl;
		while (!q[cur].empty()) {
			state tmp = q[cur].top();
			q[cur].pop();

			while (!q[cur].empty() && !(q[cur].top() < tmp) && !(tmp < q[cur].top())) {
				tmp.val += q[cur].top().val;
				if (tmp.val >= mod) {
					tmp.val -= mod;
				}
				q[cur].pop();
			}

			if (tmp.x == 0 && tmp.y == m) {
				bool f = true;
				for (int i = 0; i < n; ++i) {
					if (tmp.isX[i + 1] != table[i][m - 1]) {
						f = false;
						break;
					}
				}
				if (m > 1 && tmp.isX[0] != table[n - 1][m - 2]) {
					f = false;
				}

				if (f) {
					ans += tmp.val;
					if (ans >= mod) {
						ans -= mod;
					}
				}
			}
			else {
				tmp.go(!cur);
			}
		}
		cur = !cur;
	}
	cout << ans << "\n";
}