#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

int m;
i64 n;

const i64 MOD = 1234567891;
const int maxk = 1e5;
const int maxm = 55;

i64 rev_fact[maxk + 5];
i64 fact[maxk + 5];
i64 a[maxm];
i64 start[maxm];

i64 binpow(i64 x, i64 p)
{
	if (p == 0)
		return 1;
	i64 tmp = binpow(x, p / 2);
	tmp = (tmp * tmp) % MOD;
	if (p & 1)
		return (tmp * x) % MOD;
	else return tmp;
}

i64 rev(i64 x)
{
	return binpow(x, MOD - 2);
}

void precalc()
{
	fact[0] = 1;
	fore(j, 1, maxk)
		fact[j] = (fact[j - 1] * (i64)j) % MOD;
	forn(j, maxk + 1)
		rev_fact[j] = rev(fact[j]);
}


i64 C(i64 n, i64 k)
{
	i64 ret = 1;
	for (i64 i = n; i >= n - k + 1; i--)
		ret = (ret * (i % MOD)) % MOD;
	ret = (ret * rev_fact[k]) % MOD;
	return ret;
}

i64 get_fixators(i64 s)
{
	memcpy(a, start, sizeof(start));
	i64 L;
	if (n % 2 == 1)
	{
		int chosen = -1;
		forn(j, m)
			if (a[j] % s == 1)
			{
				chosen = j;
				break;
			}
		if (chosen == -1)
			return 0;
		a[chosen]--;
		L = (n * n - 1) / s;
	}
	else L = n * n / s;
	i64 ret = 1;
	forn(j, m)
	{
		if (a[j] % s != 0)
			return 0;
		i64 mult = C(L, a[j] / s);
		ret = (mult * ret) % MOD;
		L -= a[j] / s;
	}
	return ret;
}

i64 get_fix0()
{
	i64 ret = 1;
	i64 L = n * n;
	forn(j, m)
	{
		ret = (ret * C(L, start[j])) % MOD;
		L -= start[j];
	}
	return ret;
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	scanf("%lld%d", &n, &m);
	i64 sum = 0;
	forn(j, m)
	{
		scanf("%lld", &start[j]);
		sum += start[j];
	}
	if (sum > n * n)
	{
		printf("0");
		exit(0);
	}
	precalc();
	i64 fix1 = get_fixators(4);
	i64 fix2 = get_fixators(2);
	i64 fix0 = get_fix0();
	//printf("fix1 = %lld fix2 = %lld fix0 = %d\n", fix1, fix2, fix0);
	i64 ans = ((fix1 * 2 + fix2 + fix0) * rev(4)) % MOD;
	cout << ans;
}