#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>
#include <memory.h>
#include <unordered_map>

#define forn(i, n) for(int i = 0; i < (int)(n); ++i)
#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i) 
#define for1(i, n) for(int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

const int MAXN = 1100000;
const i64 P = 1234567891;

void add(i64 &x, i64 y) {
	x += y;
	x %= P;
	if (x < 0) x += P;
}

int mul(int x, int y) {
	return x * 1ll * y % P;
}

int power(int x, i64 n) {
	int r = 1;
	while( n ) {
		if( n & 1 ) r = mul(r, x);
		if( n /= 2 ) x = mul(x, x);
	} return r;
}

int inv(int x) {
	return power(x, P - 2);
}

i64 facts[500500];

i64 go(i64 sn, vi64 a) {
	//cerr << sn << ':';
	//for(i64 x: a) cerr << x << '\n';
	
	sort(all(a));
	i64 ans = 1;
	i64 cnt = sn - a.back(); a.pop_back();
	forn(i, cnt) ans = mul(ans, (sn - i) % P);
	forn(i, a.size())
		ans = mul((int)ans, inv(facts[a[i]]));
	return ans;
}

i64 go(i64 sn, vi64 a, int mod) {
	if( sn & 1 ) {
		int ind = -1;
		forn(i, a.size()) if( a[i] % mod != 0 ) {
			if( ind != -1 ) return 0;
			ind = i;
			if( a[i] % mod != 1 ) return 0;
			a[i] = (a[i] - 1) / mod;
		} else a[i] /= mod;
		if( sn % mod != 1 ) return 0;
		return go( (sn - 1) / mod, a);
	} else {
		forn(i, a.size()) if( a[i] % mod != 0 ) {
			return 0;
		} else a[i] /= mod;
		if( sn % mod != 0 ) return 0;
		sn /= mod;
		return go(sn, a);
	}
}

i64 solve() {
	int n, m;
	cin >> n >> m;
	vi64 a(m+1);
	forn(i, m) cin >> a[i];
	i64 nn = n * 1ll * n;
	a[m] = nn;
	forn(i, m) a[m] -= a[i];
	i64 ans = 0;
	if( a[m] < 0 ) return 0;
	ans = go( nn, a );
	i64 cans2 = go( nn, a, 2 );
	add(ans, cans2);
	i64 cans4 = go( nn, a, 4 );
	add(ans, cans4);
	add(ans, cans4);
	ans = mul(ans, inv(4));
	return ans;
}

int main() {
	facts[0] = 1;
	fore(i, 1, 500500 - 1) facts[i] = mul(facts[i-1], i);
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	i64 ans = solve();
	cout << ans % P << '\n';
	return 0;
}
