#include <bits/stdc++.h>
using namespace std;
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define mp make_pair
#define lb lower_bound
#define ub upper_bound
#define in(n) int n = nxt()
#define x first
#define y second
inline int nxt() {
    int n;
    scanf("%d", &n);
    return n;
}
typedef long long ll;
typedef long double ld;
typedef pair<int, int> PII;
typedef pair<ll, ll> PLL;

struct Edge {
    int from;
    int to;
    int cap;
    int flow;
    int cost;

    Edge(int fr, int t, int c, int co) {
        from = fr;
        to = t;
        cap = c;
        cost = co;
    }
    Edge() {}
};

const int M = 30000;
Edge edges[M];
int szE = 0;
const int N = 200;
vector<int> g[N];

void addEdge(int fr, int to, int cap, int cost) {
    edges[szE] = Edge(fr, to, cap, cost);
    g[fr].pb(szE++);
    edges[szE] = Edge(to, fr, 0, -cost);
    g[to].pb(szE++);
}

int fb(int s, int t, int n) {
    static char used[N];
    static int q[N];
    static int dist[N];
    static int parent[N];

    int cost = 0;
    int flow = 0;
    while (1) {
        memset(dist, 0x3f, sizeof(dist));
        memset(used, 0, sizeof(used));

        int qh = 0, qt = 0;
        used[s] = 1;
        dist[s] = 0;
        q[qt++] = s;
        while (qh != qt) {
            int v = q[qh++];
            used[v] = 0;
            if (qh == n) {
                qh = 0;
            }
            for (int E : g[v]) {
                Edge &e = edges[E];
                int len = e.cost;
                if (e.cap - e.flow > 0 && dist[e.to] > dist[v] + len) {
                    dist[e.to] = dist[v] + len;
                    parent[e.to] = E;
                    if (!used[e.to]) {
                        q[qt++] = e.to;
                        if (qt == n) {
                            qt = 0;
                        }
                        used[e.to] = 1;
                    }
                }
            }
        }
//        cerr << edges[parent[t]].from - ((n - 2) / 2) << " " << dist[t] << "\n";
        if (dist[t] >= 0) {
            return flow;
        }
        cost += dist[t];
        flow += 1;
        int cur = t;
        while (cur != s) {
            int E = parent[cur];
            edges[E].flow += 1;
            edges[E ^ 1].flow -= 1;
            cur = edges[E].from;
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    in(n);
    int a[n];
    for (int i = 0; i < n; ++i) {
        a[i] = nxt();
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (a[i] == a[j]) {
                addEdge(i, n + j, 1, 0);
            }
            if (abs(a[i] - a[j]) == 1) {
                addEdge(i, n + j, 1, -1);
            }
        }
    }
    int s = n + n;
    int t = n + n + 1;
    for (int i = 0; i < n; ++i) {
        addEdge(s, i, 1, 0);
        addEdge(i + n, t, 1, 0);
    }
    int res = n - fb(s, t, n + n + 2);
    cout << res << "\n";
    return 0;
}
