#include <iostream>
#include <cmath>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
const ll M = 1234567891;
inline ll binpow(ll num, ll pow){
	num %= M;
	if (num == 0) return 0;
	ll ans = 1;
	while (pow > 0){
		if (pow & 1) {
			ans *= num;
			ans %= M;
		}
		pow >>= 1;
		num *= num;
		num %= M;
	}
	return ans;
}
inline ll rev(const ll x){
	return binpow(x, M - 2); }
inline ll Cnk(const ll n, const ll k){
	if (k > n) return 0;
	ll ans = 1;
	for (int i = 0; i < k; ++i){
		ans *= (n - i) % M;
		ans %= M;
		ans *= rev(i + 1);
		ans %= M;
	}
	return ans;
}

inline ll cnt1(ll n, const vector<int>& a){
	ll ans = 1;
	ll curn = n * n;
	for (int i = 0; i < (int)a.size(); ++i){
		ans *= Cnk(curn, a[i]);
		ans %= M;
		curn -= a[i];
	}
	return ans;
}

inline ll cnt2(ll n, const vector<int>& a){
	int cnt = 0;
	int cnt1 = 0;
	for (int i = 0; i < (int)a.size(); ++i){
		if (a[i] % 2 != 0) ++cnt;
		if (a[i] % 2 == 1) ++cnt1;
	}
	if (n % 2 == 0 && cnt > 0) return 0;
	if (n % 2 == 1 && (cnt1 > 1 || cnt != cnt1)) return 0;
	

	ll ans = 1;
	ll curn = n * n / 2;
	for (int i = 0; i < (int)a.size(); ++i){
		ans *= Cnk(curn, a[i] / 2);
		ans %= M;
		curn -= a[i] / 2;
	}
	return ans;
}

inline ll cnt3(ll n, const vector<int>& a){
	int cnt = 0;
	int cnt1 = 0;
	for (int i = 0; i < (int)a.size(); ++i){
		if (a[i] % 3 != 0) ++cnt;
		if (a[i] % 3 == 1) ++cnt1;
	}
	if (n % 2 == 0 && cnt > 0) return 0;
	if (n % 2 == 1 && (cnt1 > 1 || cnt != cnt1)) return 0;

	ll ans = 1;
	ll curn = n * n / 3;
	for (int i = 0; i < (int)a.size(); ++i){
		ans *= Cnk(curn, a[i] / 3);
		ans %= M;
		curn -= a[i] / 3;
	}
	return ans;
}

inline ll cnt4(ll n, const vector<int>& a){
	int cnt = 0;
	int cnt1 = 0;
	for (int i = 0; i < (int)a.size(); ++i){
		if (a[i] % 4 != 0) ++cnt;
		if (a[i] % 4 == 1) ++cnt1;
	}
	if (n % 2 == 0 && cnt > 0) return 0;
	if (n % 2 == 1 && (cnt1 > 1 || cnt != cnt1)) return 0;

	ll ans = 1;
	ll curn = n * n / 4;
	for (int i = 0; i < (int)a.size(); ++i){
		ans *= Cnk(curn, a[i] / 4);
		ans %= M;
		curn -= a[i] / 4;
	}
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(false);
	ll n, m;
	cin >> n >> m;
	vector<int> a(m);
	for (int i = 0; i < m; ++i)
		cin >> a[i];
	/*cout << cnt1(n, a) << endl;
	cout << cnt2(n, a) << endl;
	cout << cnt3(n, a) << endl;
	cout << cnt4(n, a) << endl;*/


	ll ans = 0;
	ans += cnt1(n, a);
	ans %= M;
	ans += cnt2(n, a);
	ans %= M;
	ans += cnt4(n, a);
	ans %= M;
	ans += cnt4(n, a);
	ans %= M;
	ans *= rev(4);
	ans %= M;
	cout << ans << endl;
	return 0;
}