#pragma comment(linker, "/STACK:256000000")

#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 100500;

const ll MOD = 1234567891;

ll revVal[MAXN];
ll revFact[MAXN];
int arr[MAXN];
ll n, m;

ll
getPow(ll base, int st, ll md)
{
	ll res = 1;
	while (st) {
		if (st & 1) {
			res = 1ll * res * base % md;
		}
		st /= 2;
		base = 1ll * base * base % md;
	}
	return res;
}

void
precalc()
{
	revFact[0] = 1;
	for (int i = 1; i < MAXN; ++i) {
		revVal[i] = getPow(i, MOD - 2, MOD);
		revFact[i] = 1ll * revFact[i - 1] * revVal[i] % MOD;
	}
}

ll
getSum(int modVal)
{
	ll res = 1;
	int halfSum = 0;
	int cnt = 0;
	for (int i = 1; i <= m; ++i) {
		cnt += arr[i] % modVal;
		halfSum += arr[i] / modVal;
	}
	if (cnt > n % 2) {
		return 0ll;
	}
	ll curVal = (1ll * n * n / modVal) % MOD;
	for (int i = 1; i <= halfSum; ++i) {
		res = 1ll * res * curVal % MOD;
		curVal = (curVal + MOD - 1) % MOD;
	}
	for (int i = 1; i <= m; ++i) {
		res = 1ll * res * revFact[arr[i] / modVal] % MOD;
	}
	return res;
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 

	precalc();
	cin >> n >> m;
	ll val = 1ll * n * n;
	int sum = 0;
	for (int i = 1; i <= m; ++i) {
		cin >> arr[i];
		sum += arr[i];
	}
	if (sum > val) {
		cout << "0\n";
		return 0;
	}
	ll res = 0;
	ll all = getSum(1);
	ll all2 = getSum(2), all3 = getSum(4);
	ll b = all3;
	ll d = all2 - all3;
	while (d < 0) {
		d += MOD;
	}
	ll c = (all - b - 2 * d);
	while (c < 0) {
		c += MOD;
	}
	c = 1ll * c * revVal[4] % MOD;
	res = ((b + c) % MOD + d) % MOD;
	cout << res << '\n';

	return 0;
}