#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

const llong MOD = 1234567891;

llong n;
int m;
	
llong powmod(llong x, int b)
{
	llong ans = 1;
	while (b)
	{
		if (b & 1)
			ans = (ans * x) % MOD;
		x = (x * x) % MOD;
		b >>= 1;
	}
	return ans;
}

llong inv(llong x)
{
	return powmod(x, MOD - 2);
}

const int N = 100500;

llong IF[N];

map<pair<llong, llong>, llong> cache;


llong A[N], A2[N], A4[N];

llong get(llong r, int fact)
{
	r %= MOD;
	bool bad = false;

	llong sum = 0;
	for (int i = 0; i < m; i++)
	{
		if (A[i] % fact)
			return false;
		sum += A[i] / fact;
	}

	llong u;
	if (cache.find(make_pair(r, sum)) != cache.end())
		u = cache[make_pair(r, sum)];
	else
	{
		u = 1;
		for (int i = 0; i < sum; i++)
			u = u * (r - i + MOD) % MOD;
		cache[make_pair(r, sum)] = u;
	}

	llong d = 1;
	for (int i = 0; i < m; i++)
	{
		if (A[i] % fact)
			bad = true;
		d = d * IF[A[i] / fact] % MOD;
	}
	if (!bad)
		return u * d % MOD;
	else
		return 0;
}


void solve_even()
{
	
	llong a = 0, b = 0, c = 0;
	a = get(n * n / 4,  4);
	b = get(n * n / 2, 2);
	b = (b - a + MOD) % MOD;
	b = b * inv(2) % MOD;
	c = get(n * n, 1);
	c = (c - a - 2 * b + MOD + MOD + MOD) % MOD;
	c = c * inv(4) % MOD;
	llong ans = (a + b + c) % MOD;
	printf(LLD "\n", ans);
}

void solve_odd()
{
	llong a = 0, b = 0, c = 0;
	
	for (int i = 0; i <= m; i++)
	{
		if (A[i] == 0)
			continue;
		--A[i];
		a = (a + get(n * n / 4, 4)) % MOD;
		++A[i];
	}

	for (int i = 0; i <= m; i++)
	{
		if (A[i] == 0)
			continue;
		--A[i];
		b = (b + get(n * n / 2, 2)) % MOD;
		++A[i];
	}
	b = (b - a + MOD) % MOD;
	b = b * inv(2) % MOD;
	
	c = (get(n * n, 1)) % MOD;
	c = (c - 2 * b - a + 3 * MOD) % MOD;
	c = c * inv(4) % MOD;
	llong ans = (a + b + c) % MOD;
	printf(LLD "\n", ans);
}

int main() {
#ifdef LOCAL42
#define TASK "B"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	 
	IF[0] = 1;
	for (int i = 1; i < N; i++)
		IF[i] = (IF[i - 1] * inv(i)) % MOD;

	scanf(LLD " %d", &n, &m);
	for (int i = 0; i < m; i++)
		scanf(LLD, &A[i]);
	A[m] = 1;
	llong sum = 0;
	for (int i = 0; i < m; i++)
		sum += A[i];

	if (sum > n * n)
	{
		puts("0");
		exit(0);
	}

	if (!(n & 1))
		solve_even();
	else
		solve_odd();

	return 0;
}
