#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 4;
const int MOD = 12345678;
const int HASH_MOD = (1 << 24);
const int SIZE = (1 << 21);

int n, m;

struct state {

	char a[N + 1];
	char is_min;

	inline void set_min(int pos, int val) {
		if (val) {
			is_min |= (1 << pos);
			return;
		}
		if ((is_min >> pos) & 1) {
			is_min ^= (1 << pos);
		}
	}

	inline char get_min(int pos) const {
		return (is_min >> pos) & 1;
	}

	inline int hash() {
		int res = 0;
		const int X = 37;
		for (int i = 0; i < n + 1; ++i) {
			res = res * X + a[i] + 1;
		}
		res = res * X + is_min + 1;
		return res;
	}

};

bool operator < (const state &a, const state &b) {
	if (a.is_min != b.is_min) {
		return a.is_min < b.is_min;
	}
	for (int i = 0; i < n + 1; ++i) {
		if (a.a[i] != b.a[i]) {
			return a.a[i] < b.a[i];
		}
	}
	return false;
}

bool operator == (const state &a, const state &b) {
	if (a.is_min != b.is_min) {
		return false;
	}
	for (int i = 0; i < n + 1; ++i) {
		if (a.a[i] != b.a[i]) {
			return false;
		}
	}
	return true;
}

inline void add(int &a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

double avg = 0;
int cnt = 0;

struct hash_table {

	int sz, ver;
	int first[HASH_MOD], used[HASH_MOD];
	state s[SIZE];
	int val[SIZE], next[SIZE];

	hash_table() {
		ver = 0;
	}

	inline void clear() {
		sz = 0;
		++ver;
	}

	inline void add(state &cur, int val) {
		int need = cur.hash() & (HASH_MOD - 1);
		if (used[need] != ver) {
			used[need] = ver;
			first[need] = 0;
		}
		++cnt;
		int szz = 0;
		for (int i = first[need]; i > 0; i = next[i]) {
			++szz;
			if (s[i] == cur) {
				::add(this->val[i], val);
				avg += szz;
				return;
			}
		}
		assert(sz + 1 < SIZE);
		avg += szz;
		s[++sz] = cur;
		this->val[sz] = val;
		next[sz] = first[need];
		first[need] = sz;
	}

};

int ans = 0, cur_t = 0;
char a[10][10];
bool used[30];
int perm[10];
hash_table t[2];

void gen1(int x) {
	if (x >= n) {
		for (int i = 0; i < n; ++i) {
			bool is_min = true;
			if (i > 0 && perm[i - 1] < perm[i]) {
				is_min = false;
			}
			if (i + 1 < n && perm[i + 1] < perm[i]) {
				is_min = false;
			}
			if (is_min != a[i][0]) {
				return;
			}
		}
		++ans;
		return;
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			perm[x] = i;
			used[i] = true;
			gen1(x + 1);
			used[i] = false;
		}
	}
}

void gen2(int x) {
	if (x >= n + 1) {
		state cur;
		for (int i = 0; i < n + 1; ++i) {
			cur.a[i] = perm[i];
		}
		for (int i = 0; i <	n + 1; ++i) {
			cur.set_min(i, true);
			if (i > 0 && cur.a[i - 1] < cur.a[i]) {
				cur.set_min(i, false);
			}
			if (i + 1 < n + 1 && cur.a[i + 1] < cur.a[i]) {
				cur.set_min(i, false);
			}
			if (i == 0 && cur.a[2] < cur.a[0]) {
				cur.set_min(0, false);
			}
			if (i == 2 && cur.a[0] < cur.a[2]) {
				cur.set_min(2, false);
			}
		}
		t[cur_t].add(cur, 1);
		return;
	}
	for (int i = 0; i < n + 1; ++i) {
		if (!used[i]) {
			perm[x] = i;
			used[i] = true;
			gen2(x + 1);
			used[i] = false;
		}
	}
}

int main() {
#ifdef LOCAL42
#define TASK "C"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	scanf("%d %d", &n, &m);
	gets(a[0]);
	for (int i = 0; i < n; ++i) {
		gets(a[i]);
		for (int j = 0; j < m; ++j) {
			a[i][j] = (a[i][j] == 'X');
		}
	}
	if (m == 1) {
		gen1(0);
		cout << ans << endl;
		return 0;
	}
	if (n == 1) {
		for (int i = 0; i < m; ++i) {
			a[i][0] = a[0][i];
		}
		swap(n, m);
		gen1(0);
		cout << ans << endl;
		return 0;
	}
	gen2(0);
	for (int i = 1; i < m; ++i) {
		for (int j = 0; j + 1 < n; ++j) {
			t[1 - cur_t].clear();
			cerr << i << " " << j << " " << t[cur_t].sz << endl;
			double start = clock();
			for (int it = 1; it <= t[cur_t].sz; ++it) {
				for (int z = 0; z < i * n + j + 2; ++z) {
					state cur = t[cur_t].s[it];
					for (int h = 0; h < n + 1; ++h) {
						if (cur.a[h] >= z) {
							++cur.a[h];
						}
					}
					if (cur.a[j] >= z) {
						cur.set_min(j, false);
					}
					if (cur.a[j + 1] >= z) {
						cur.set_min(j + 1, false);
					}
					if (cur.a[j + 2] >= z) {
						cur.set_min(j + 2, false);
					}
					if (j + 2 < n && cur.a[j + 3] >= z) {
						cur.set_min(j + 3, false);
					}
					if (cur.get_min(j + 1) != a[j][i - 1]) {
						continue;
					}
					if (i == m && cur.get_min(j) != a[j][m - 1]) {
						continue;
					}
					cur.set_min(j + 1, true);
					if (cur.a[j + 1] < z) {
						cur.set_min(j + 1, false);
					}
					cur.a[j + 1] = z;
					if (cur.a[j] < z) {
						cur.set_min(j + 1, false);
					}
					if (cur.a[j + 2] < z) {
						cur.set_min(j + 1, false);
					}
					if (j + 2 < n && cur.a[j + 3] < z) {
						cur.set_min(j + 1, false);
					}
					t[1 - cur_t].add(cur, t[cur_t].val[it]);
				}
			}
			double end = clock();
			eprintf("Time %.18lf\n", (end - start) / CLOCKS_PER_SEC / t[cur_t].sz);
			cur_t = 1 - cur_t;
		}
		if (i + 1 < m) {
			t[1 - cur_t].clear();
			for (int it = 1; it <= t[cur_t].sz; ++it) {
				if (t[cur_t].s[it].get_min(n) != a[n - 1][i - 1]) {
					continue;
				}
				for (int z = 0; z < (i + 1) * n + 1; ++z) {
					state cur;
					cur.a[0] = z;
					cur.set_min(0, true);
					for (int h = 0; h < n; ++h) {
						cur.a[h + 1] = t[cur_t].s[it].a[h];
						if (cur.a[h + 1] >= z) {
							++cur.a[h + 1];
						}
						cur.set_min(h + 1, t[cur_t].s[it].get_min(h));
					}
					if (cur.a[1] < cur.a[0]) {
						cur.set_min(0, false);
					}
					if (cur.a[0] < cur.a[1]) {
						cur.set_min(1, false);
					}
					if (cur.a[2] < cur.a[0]) {
						cur.set_min(0, false);
					}
					if (cur.a[0] < cur.a[2]) {
						cur.set_min(2, false);
					}
					t[1 - cur_t].add(cur, t[cur_t].val[it]);
				}
			}
			cur_t = 1 - cur_t;
		}
	}
	int ans = 0;
	for (int it = 1; it <= t[cur_t].sz; ++it) {
		if (t[cur_t].s[it].get_min(n) != a[n - 1][m - 2]) {
			continue;
		}
		bool good = true;
		for (int i = 0; i < n; ++i) {
			if (t[cur_t].s[it].get_min(i) != a[i][m - 1]) {
				good = false;
				break;
			}
		}
		if (good) {
			add(ans, t[cur_t].val[it]);
		}
	}
	cerr << avg / cnt << endl;
	cout << ans << endl;
	cerr << 1.0 * clock() / CLOCKS_PER_SEC << endl;
	return 0;
}
