#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef unsigned long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

const LL MOD = 1234567891;
LL mpow(LL x, LL p) {
  LL y = 1;
  while (p) {
    if (p & 1) y = y * x % MOD;
    x = x * x % MOD;
    p /= 2;
  }
  return y;
}
LL minv(LL x) {
  return mpow(x, MOD - 2);
}

LL cnk(LL n, LL k) {
  if (k < 0 || k > n) return 0;
  if (n - k < k) k = n - k;
  LL num = 1;
  LL den = 1;
  for (LL i = 0; i < k; i++) {
    num = num * ((n - i) % MOD) % MOD;
    den = den * (i + 1) % MOD;
  }
  return num * minv(den) % MOD;
}

LL cnt[64];

LL comp0(LL n, int m) {
  LL res = 1;
  FOR(i, 0, m) {
    res = res * cnk(n, cnt[i]) % MOD;
    n -= cnt[i];
  }
  return res;
}
LL comp1a(LL n, int m) {
  bool ok = true;
  FOR(j, 0, m) if (cnt[j] & 1) ok = false;
  if (!ok) return 0;
  FOR(j, 0, m) cnt[j] /= 2;
  LL result = comp0(n * n / 2, m);
  FOR(j, 0, m) cnt[j] *= 2;
  return result;
}
LL comp1(LL n, int m) {
  if (n & 1) {
    LL res = 0;
    FOR(i, 0, m + 1) {
      if (i < m) cnt[i]--;
      res = (res + comp1a(n, m)) % MOD;
      if (i < m) cnt[i]++;
    }
    return res;
  }
  return comp1a(n, m);
}
LL comp2a(LL n, int m) {
  bool ok = true;
  FOR(j, 0, m) if (cnt[j] & 3) ok = false;
  if (!ok) return 0;
  FOR(j, 0, m) cnt[j] /= 4;
  LL result = comp0(n * n / 4, m);
  FOR(j, 0, m) cnt[j] *= 4;
  return result;
}
LL comp2(LL n, int m) {
  if (n & 1) {
    LL res = 0;
    FOR(i, 0, m + 1) {
      if (i < m) cnt[i]--;
      res = (res + comp2a(n, m)) % MOD;
      if (i < m) cnt[i]++;
    }
    return res;
  }
  return comp2a(n, m);
}

int main() {
  LL n; int m;
  cin >> n >> m;
  FOR(i, 0, m) cin >> cnt[i];

  LL a0 = comp0(n * n, m);
  LL a1 = comp1(n, m);
  LL a2 = comp2(n, m);
  cout << ((a0 + a1 + a2 + a2) % MOD) * minv(4) % MOD;

  return 0;
}
