#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

/*
struct State {
  int acur, anext, bprev, bcur;
};
struct StateHash {
  size_t operator()(State const& state) const {
    return state.acur * 1030301 + state.anext * 10201 + state.bprev * 101 + state.bcur;
  }
};
bool operator == (State const& a, State const& b) {
  return a.acur == b.acur && a.anext == b.anext && a.bprev == b.bprev && a.bcur == b.bcur;
}
*/

int cnt[128];

typedef int State[64][64][64][64];
State sm[2];

inline void relax(int& a, int b) {
  if (a < b) a = b;
}

int main() {
  int n;
  cin >> n;
  FOR(i, 0, n) {
    int x; cin >> x;
    cnt[x - 1]++;
  }

  int pos = 0;
  memset(sm[pos], 255, sizeof sm[pos]);
  sm[pos][cnt[0]][cnt[1]][0][cnt[0]] = 0;
  FOR(i, 0, 100) {
    State& dp = sm[pos];
    State& dpn = sm[1 - pos];
    memset(dpn, 255, sizeof dpn);
    int a3 = cnt[i + 2];
    int b2 = cnt[i + 1];
    FOR(a1, 0, cnt[i] + 1) FOR(a2, 0, cnt[i + 1] + 1) FOR(b0, 0, (i ? cnt[i - 1] : 0) + 1) FOR(b1, 0, cnt[i] + 1) {
      int val = dp[a1][a2][b0][b1];
      if (val < 0) continue;
      
      // all
      int to = min(a1, b1);
      FOR(x, 0, to + 1) {
        int y = min(a1 - x, b2);
        relax(dpn[a2][a3][b1 - x][b2 - y], val);
      }

      // some
      to = min(a3, b2);
      FOR(x, b0, a1 + 1) FOR(z, 0, to + 1) {
        int y = b0 + b1 + b2 - x - z;
        if (y >= 0 && y <= a2) {
          relax(dpn[a2 - y][a3 - z][0][0], val + a1 - x);
        }
      }
    }
    pos = 1 - pos;
  }

  int answer = 0;
  FOR(i, 0, cnt[99] + 1) {
    relax(answer, sm[pos][0][0][i][0]);
  }
  cout << answer;

  return 0;
}
