#include <iostream>

using namespace std;

const int MAXM = 55, MAXN = 100 * 1000 + 5;
long long MOD = 1234567891;
long long a[MAXM], b[MAXM], factinv[MAXN];

pair<long long, long long> gcd(long long a, long long b) {
    if(!b)
        return make_pair(1, 0);
    pair<long long, long long> p = gcd(b, a % b);
    return make_pair(p.second, p.first - p.second * (a / b));
}

long long inv(int x) {
    return gcd(x, MOD).first;
}

int getPol(long long n, int m, long long *a) {
    long long sum = 0, res = 1;
    for(int i = 0; i < m; i++) {
        sum += a[i];
        res = (res * factinv[a[i]]) % MOD;
    }
    n %= MOD;
    for(long long i = 0; i < sum; i++)
        res = (res * (n - i)) % MOD;
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    factinv[0] = 1;
    for(long long i = 1; i < MAXN; i++)
        factinv[i] = (factinv[i - 1] * i) % MOD;
    for(int i = 0; i < MAXN; i++)
        factinv[i] = inv(factinv[i]);
    int n, m;
    cin >> n >> m;
    long long sum = 0;
    for(int i = 0; i < m; i++) {
        cin >> a[i];
        sum += a[i];
    }
    if(sum > (long long)n * n) {
        cout << 0 << '\n';
        return 0;
    }
    if(n == 1) {
        cout << 1 << '\n';
        return 0;
    }
    long long ans = (long long)getPol((long long)n * n, m, a) % MOD, ans0 = 0, ans1 = 0;
    int cnt = 0;
    /*ans = (ans + MOD) % MOD;
    cout << ans << '\n';*/
    for(int i = 0; i < m; i++)
        if(a[i] % 2)
            cnt++;
    if(cnt <= (n % 2)) {
        for(int i = 0; i < m; i++)
            b[i] = a[i] / 2;
        ans0 = getPol(((long long)n * n) / 2, m, b);
    }
    /*ans0 = (ans0 + MOD) % MOD;
    cout << ans0 << '\n';*/
    cnt = 0;
    for(int i = 0; i < m; i++)
        if(a[i] % 4)
            cnt++;
    if(cnt <= (n % 2)) {
        for(int i = 0; i < m; i++)
            b[i] = a[i] / 4;
        ans1 = getPol(((long long)n * n) / 4, m, b);
    }
    /*ans1 = (ans1 + MOD) % MOD;
    cout << ans1 << '\n';*/
    ans0 = ((ans0 - ans1) * inv(2)) % MOD;
    ans = (((ans - (2LL * ans0 % MOD)) % MOD - ans1) * inv(4)) % MOD;
    ans = (((ans + ans0) % MOD) + ans1) % MOD;
    ans = (ans + MOD) % MOD;
    cout << ans << '\n';
    return 0;
}
