#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;
typedef pair<ll, ll> pl;

const int MAX_N = 100600;
const int MOD = 1234567891;
const int MAX_M = 51;

ll ch[MAX_M];

ll fact[MAX_N];
ll ifact[MAX_N];

ll binpow(ll n, int deg)
{
	if (deg == 0) return 1;
	if (deg % 2 == 0)
	{
		ll b = binpow(n, deg / 2);
		return (b * b) % MOD;
	}
	return (binpow(n, deg - 1) * n) % MOD;
}

ll inv(ll n)
{
	return binpow(n, MOD - 2);
}

ll C(ll n, ll k)
{
	if (k > n) return 0;
	ll res = 1;
	for (ll i = 0; i < k; i++)
	{
		res *= (n - i);
		res %= MOD;
	}
	return (res * ifact[k]) % MOD;
	//return (((fact[n] * ifact[k]) % MOD) * ifact[n - k]) % MOD;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

	fact[0] = 1;
	ifact[0] = inv(1);
	for (int i = 1; i < MAX_N; i++)
	{
		fact[i] = (ll)i * fact[i - 1];
		fact[i] %= MOD;
		ifact[i] = inv(fact[i]);
	}

	ll n, m;
	cin >> n >> m;
	ll total_ch = 0;
	for (int i = 0; i < m; ++i)
	{
		cin >> ch[i];
		total_ch += ch[i];
	}

	if (total_ch > n*n)
	{
		cout << 0;
		return 0;
	}

	ll s4 = 1;
	ll from = (n * n) % MOD;
	for (int i = 0; i < m; ++i)
	{
		s4 = (s4 * C(from, ch[i]));
		s4 %= MOD;
		from = (from - ch[i] + MOD) % MOD;
	}

	ll s2 = 0;
	if (n % 2 == 0)
	{
		bool good = true;
		for (int i = 0; i < m; ++i)
		{
			if (ch[i] % 2 != 0)
			{
				good = false;
				break;
			}
		}

		if (good)
		{
			s2 = 1;
			ll from = (n * n / 2) % MOD;
			for (int j = 0; j < m; ++j)
			{
				s2 = (s2 * C(from, ch[j] / 2)) % MOD;
				from = (from - ch[j] / 2 + MOD) % MOD;
			}
		}
	}
	else
	{
		bool very_good = false;
		for (int i = 0; i < m; ++i)
		{
			bool good = true;
			if (ch[i] % 2 == 1)
			{
				for (int j = 0; j < m; ++j)
				{
					if (i == j)
					{
						continue;
					}
					if (ch[j] % 2 != 0)
					{
						good = false;
						break;
					}
				}
			}
			else
			{
				good = false;
			}

			if (good)
			{
				ch[i] -= 1;

				s2 = 1;
				ll from = (n * n / 2) % MOD;
				for (int j = 0; j < m; ++j)
				{
					s2 = (s2 * C(from, ch[j] / 2)) % MOD;
					from = (from - ch[j] / 2 + MOD) % MOD;
				}

				ch[i] += 1;
				very_good = true;
				break;
			}
		}

		if (!very_good)
		{
			bool good = true;
			for (int i = 0; i < m; ++i)
			{
				if (ch[i] % 2 != 0)
				{
					good = false;
					break;
				}
			}

			if (good)
			{
				s2 = 1;
				ll from = (n * n / 2) % MOD;
				for (int j = 0; j < m; ++j)
				{
					s2 = (s2 * C(from, ch[j] / 2)) % MOD;
					from = (from - ch[j] / 2 + MOD) % MOD;
				}
			}
		}

	}

	ll s1 = 0;
	if (n % 2 == 0)
	{
		bool good = true;
		for (int i = 0; i < m; ++i)
		{
			if (ch[i] % 4 != 0)
			{
				good = false;
				break;
			}
		}

		if (good)
		{
			s1 = 1;
			ll from = (n * n / 4) % MOD;
			for (int j = 0; j < m; ++j)
			{
				s1 = (s1 * C(from, ch[j] / 4)) % MOD;
				from = (from - ch[j] / 4 + MOD) % MOD;
			}
		}
	}
	else
	{
		bool very_good = false;
		for (int i = 0; i < m; ++i)
		{
			bool good = true;
			if (ch[i] % 4 == 1)
			{
				for (int j = 0; j < m; ++j)
				{
					if (i == j)
					{
						continue;
					}
					if (ch[j] % 4 != 0)
					{
						good = false;
						break;
					}
				}
			}
			else
			{
				good = false;
			}

			if (good)
			{
				ch[i] -= 1;

				s1 = 1;
				ll from = ((n * n - 1) / 4) % MOD;
				for (int j = 0; j < m; ++j)
				{
					s1 = (s1 * C(from, ch[j] / 4)) % MOD;
					from = (from - ch[j] / 4 + MOD) % MOD;
				}

				ch[i] += 1;
				very_good = true;
				break;
			}
		}

		if (!very_good)
		{
			bool good = true;
			for (int i = 0; i < m; ++i)
			{
				if (ch[i] % 4 != 0)
				{
					good = false;
					break;
				}
			}

			if (good)
			{
				s1 = 1;
				ll from = ((n * n - 1) / 4) % MOD;
				for (int j = 0; j < m; ++j)
				{
					s1 = (s1 * C(from, ch[j] / 4)) % MOD;
					from = (from - ch[j] / 4 + MOD) % MOD;
				}
			}
		}
	}

	ll su1 = (s4 - s2 + MOD) % MOD;
	su1 = (su1 * inv(4)) % MOD;

	ll su2 = (s2 - s1 + MOD) % MOD;
	su2 = (su2 * inv(2)) % MOD;

	ll ans = (su1 + su2 + s1) % MOD;

	cout << ans;

    return 0;
}