#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
#include <bitset>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 200*1000 + 10;
const dbl eps = 1e-7;
const ll mod = 1234567891;

ll ppow (ll a, ll b) {
	if (b == 0)
		return 1LL;
	if (b % 2 == 0) {
		ll t = ppow(a, b/2);
		return (t * t) % mod;
	}
	else {
		return (a * ppow(a, b - 1)) % mod;
	}
}

ll cnk (ll k, ll n) {
	if (n == 0) {
		if (k == 0)
			return 1;
		else
			return 0;
	}
	ll ch = 1;
	for (ll i = n; i >= n - k + 1; i--)
		ch = (ch * (i % mod)) % mod;
	ll zn = 1;
	for (ll i = 1; i <= k; i++)
		zn = (zn * i) % mod;
	return (ch * ppow(zn, mod - 2)) % mod;
}

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
#define TES
	#ifdef TEST
	int n = 10;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cout << i*j / n << i*j % n << ' ';
		}
		puts("");
	}
	return 0;
	

#else
	ll n, m;
	scanf("%lld%lld", &n, &m);
	vector <ll> v(m);
	ll s = 0;
	for (int i = 0; i < m; i++)  {
		scanf("%lld", &v[i]);
		s += v[i];
	}
	if (s > n*n) {
		puts("0");
		return 0;
	}
	if (n == 1) {
		puts("1");
		return 0;
	}

	ll all = 1;
	ll cur = n*n;
	for (int i = 0; i < m; i++) {
		all = (all * cnk(v[i], cur)) % mod;
		cur -= v[i];
	}

	ll half = 1;
	if (n % 2 == 0) {
		bool ok = true;
		for (int i = 0; i < m; i++)
			if (v[i] % 2 != 0)
				ok = false;
		if (ok) {
			ll t = n*n/2;
			for (int i = 0; i < m; i++) {
				half = (half * cnk(v[i]/2, t)) % mod;
				t -= v[i]/2;
			}
		}
		else
			half = 0;
	}
	else {
		int cnt = 0;
		for (int i = 0; i < m; i++)
			if (v[i] % 2 != 0)
				cnt++;
		if (cnt <= 1) {
			ll t = n*n/2;
			for (int i = 0; i < m; i++) {
				half = (half * cnk(v[i]/2, t)) % mod;
				t -= v[i]/2;
			}
		}
		else
			half = 0;
	}

	ll quat = 1;
	if (n % 2 == 0) {
		bool ok = true;
		for (int i = 0; i < m; i++)
			if (v[i] % 4 != 0)
				ok = false;
		if (ok) {
			ll t = n*n/4;
			for (int i = 0; i < m; i++) {
				quat = (quat * cnk(v[i]/4, t)) % mod;
				t -= v[i]/4;
			}
		}
		else
			quat = 0;
	}
	else {
		int cnt = 0;
		for (int i = 0; i < m; i++)
			if (v[i] % 4 == 1)
				cnt++;
		if (cnt <= 1) {
			ll t = n*n/4;
			for (int i = 0; i < m; i++) {
				quat = (quat * cnk(v[i]/4, t)) % mod;
				t -= v[i]/4;
			}
		}
		else
			quat = 0;
	}

	printf("%lld", (((all + half + 2*quat)%mod)*ppow(4, mod - 2)) % mod);
#endif
}