#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <assert.h>
using namespace std;

#define EPS 1E-7
const long long MOD = 1234567891;
#define mp make_pair

long long binpow(long long a, long long p){
	if(!p)return 1;
	if(p%2) return (a*binpow(a,p-1))%MOD;
	long long t = binpow(a,p/2);
	return (t*t)%MOD;
}

long long inv(long long a){
	return binpow(a, MOD-2);
}

vector<long long>fact(100001);
vector<long long>inv_fact(100001);


long long C(long long n, long long k){
	if(n-k < k){
		return C(n,n-k);
	}
	long long res=inv_fact[k];
	for(long long i=0; i<k; ++i){
		res*=(n-i);
		res%=MOD;
	}
	return res;
}


long long P(long long n, vector<long long>&a){
	long long currn=n;
	long long res=C(n,a[0]);
	for(int i=1; i<a.size(); ++i){
		currn-=a[i-1];
		res*=C(currn, a[i]);
		res%=MOD;
	}
	return res;
}



int main(){
	freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
	fact[0]=inv_fact[0]=1;
	for(long long i=1; i<=100000; ++i){
		fact[i]=(fact[i-1]*i)%MOD;
		inv_fact[i]=inv(fact[i]);
	}

	long long n,m;
	cin>>n>>m;
	vector<long long>cnt(m);
	long long ss=0;
	for(int i=0; i<m; ++i){
		cin>>cnt[i];
		ss+=cnt[i];
	}

	if(ss>n*n){
		cout<<0;
		return 0;
	}
	cnt.push_back(n*n-ss);
	m++;

	if(n%2){
		long long tot = P(n*n, cnt);
		long long res = inv(4);

		long long sum = tot; // 360 added
		sum%=MOD;


		//90 & 270
		long long badcnt=0;
		long long verybadcnt=0;
		long long pos=-1;
		for(long long i=0; i<cnt.size(); ++i){
			if(cnt[i]%4==1){
				badcnt++;
				pos=i;
			}
			if(cnt[i]%4){
				verybadcnt++;
			}
		}
		if(verybadcnt==1 && badcnt==1){// exist! j such that a[j]%4==1
			vector<long long>cnt1=cnt;
			cnt1[pos]--;
			for(int i=0; i<cnt1.size(); ++i){
				cnt1[i]/=4;
			}
			sum += (2*P((n/2) * (n+1)/2, cnt1))%MOD;
			sum%=MOD;

		}
		else if(verybadcnt==0){
			vector<long long>cnt1=cnt;
			for(int i=0; i<cnt1.size(); ++i){
				cnt1[i]/=4;
			}
			sum += (2*P((n/2) * (n+1)/2, cnt))%MOD;
			sum%=MOD;
		}
		// end 90&270


		//180
		badcnt=0;
		pos=-1;
		for(long long i=0; i<cnt.size(); ++i){
			if(cnt[i]%2==1){
				badcnt++;
				pos=i;
			}
		}
		if(badcnt<=1){
			if(badcnt==1){
				vector<long long>cnt1=cnt;
				cnt1[pos]--;
				for(int i=0; i<cnt1.size(); ++i){
					cnt1[i]/=2;
				}
				sum += P(n*(n/2)+(n/2), cnt1);
				sum%=MOD;
			}
			else{
				vector<long long>cnt1=cnt;
				for(int i=0; i<cnt1.size(); ++i){
					cnt1[i]/=2;
				}
				sum += P(n*(n/2)+(n/2), cnt1);
				sum%=MOD;
			}
		}

		res=res*sum;
		res%=MOD;
		cout<<res;
	}
	else{
		long long tot = P(n*n, cnt);
		long long res = inv(4);

		long long sum = tot; // 360 added
			sum%=MOD;


		//90 & 270
		long long badcnt=0;
		for(long long i=0; i<cnt.size(); ++i){
			if(cnt[i]%4){
				badcnt++;
			}
		}
		if(badcnt==0){
			vector<long long>cnt1=cnt;
			for(long long i=0; i<cnt1.size(); ++i){
				cnt1[i]/=4;
			}
			sum += (2*P((n/2)*(n/2), cnt1))%MOD;
			sum%=MOD;

		}
		// end 90&270


		//180
		badcnt=0;
		for(int i=0; i<cnt.size(); ++i){
			if(cnt[i]%2){
				badcnt++;
			}
		}
		if(badcnt==0){
			vector<long long>cnt1=cnt;
			for(int i=0; i<cnt1.size(); ++i){
				cnt1[i]/=2;
			}
			sum += P(n*(n/2), cnt1);
			sum%=MOD;
		}
		res=res*sum;
		res%=MOD;
		cout<<res;
	}


	return 0;
}