#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

const int N = 3 * 1000 * 1000 + 5;

int n, m;
int dp[2][N];

bool read() {
	if (scanf("%d %d", &m, &n) != 2)
		return false;
	memset(dp, 0, sizeof(dp));
	return true;
}

const int MOD = int(1e9) + 9;

int moves(int k, int m) {
	int res = 0;
	while (k != 1) {
		if (k % m == 0)
			k /= m;
		else
			k++;
		res++;
	}
	return res;
}

int naive(int n, int m) {
	int pw = 1;
	forn(i, n)
		pw *= m;

	int res = 0;

	forn(i, pw)
		res += moves(i + 1, m) == n;

	return res;
}

void solve() {
	dp[0][0] = 0;
	dp[1][0] = 1;
	dp[1][1] = (-1 + MOD) % MOD;

	forn(i, n + 1) {
		if (i)
			dp[1][i] = (dp[1][i - 1] + dp[1][i]) % MOD;
		dp[0][i + 1] = (dp[0][i] + dp[1][i]) % MOD;
		
		dp[1][i + 1] = (dp[1][i + 1] + dp[0][i]) % MOD;
		int d = m;
		if (i == 1)
			d--;

		dp[1][i + d] = (dp[1][i + d] - dp[0][i] + MOD) % MOD;
	}

	int res = (dp[0][n] + dp[1][n]) % MOD;

/*	int nres = naive(n, m);

	if(res != nres) {
		assert(false);
	}*/

	cout << res << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	while(read())
		solve();

	return 0;
}