#include <iostream>
#include <climits>

using namespace std;
typedef unsigned long long int Z;

const Z M = 1234567891;

Z n, m;
Z c[50];

Z modpow(Z a, Z b) {
	if(b == 0) return 1;
	if(b & 1) return a * modpow(a, b - 1) % M;
	Z x = modpow(a, b / 2);
	return x * x % M;
}
Z inv_(Z x) {
	return modpow(x, M - 2);
}
Z inv[100005];

Z prod(Z a, Z b) {
	Z ret = 1;
	for(Z i = a; i <= b; ++i) {
		ret *= i;
		ret %= M;
	}
	return ret;
}
Z invprod(Z a, Z b) {
	Z ret = 1;
	for(Z i = a; i <= b; ++i) {
		ret *= inv[i];
		ret %= M;
	}
	return ret;
}


int main() {
	for(Z i = 0; i < 100005; ++i) inv[i] = inv_(i);

	cin >> n >> m;
	
	Z csum = 0;
	Z oddcount = 0;
	Z nonfourcount = 0;
	Z mod4 = 0;
	for(Z i = 0; i < m; ++i) {
		cin >> c[i];
		csum += c[i];
		if(c[i] & 1) ++oddcount;
		if(c[i] & 3) {
			++nonfourcount;
			mod4 = c[i] & 3;
		}
	}
	
	Z A, B, C;
	if(n % 2 == 0) {
		A = prod(n * n - csum + 1, n * n);
		for(Z i = 0; i < m; ++i) {
			A *= invprod(1, c[i]);
			A %= M;
		}
		
		B = 0;
		if(oddcount == 0) {
			B = prod(n * n / 2 - csum / 2 + 1, n * n / 2);
			for(Z i = 0; i < m; ++i) {
				B *= invprod(1, c[i] / 2);
				B %= M;
			}
		}
		
		C = 0;
		if(nonfourcount == 0) {
			C = prod(n * n / 4 - csum / 4 + 1, n * n / 4);
			for(Z i = 0; i < m; ++i) {
				C *= invprod(1, c[i] / 4);
				C %= M;
			}
		}
	} else {
		A = prod(n * n - csum + 1, n * n);
		for(Z i = 0; i < m; ++i) {
			A *= invprod(1, c[i]);
			A %= M;
		}
		
		B = 0;
		if(oddcount <= 1) {
			B = prod(n * n / 2 - (csum - oddcount) / 2 + 1, n * n / 2);
			for(Z i = 0; i < m; ++i) {
				B *= invprod(1, (c[i] / 2) * 2);
				B %= M;
			}
		}
		
		C = 0;
		if(nonfourcount <= 1 && mod4 == 1) {
			C = prod(n * n / 4 - (csum - mod4) / 4 + 1, n * n / 4);
			for(Z i = 0; i < m; ++i) {
				C *= invprod(1, (c[i] / 4) * 4);
				C %= M;
			}
		}
	}
	
	Z ret = A;
	ret %= M;
	ret += B;
	ret %= M;
	ret += B;
	ret %= M;
	ret += C;
	ret %= M;
	ret *= inv[4];
	ret %= M;
	cout << ret << "\n";

 	return 0;
}