#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

const int N = 500500;
const int INF = 1e9;
const int BASE = 1234567891;

int n, m;
long long rev[N];

long long mul(long long _a, long long _b) {
	unsigned long long a = _a;
	unsigned long long b = _b;
	unsigned long long c = a * b;
	return c % BASE;
}

long long pw(long long x, long long y) {
	long long res = 1;
	while (y) {
		if (y % 2) {
			res = (res * 1LL * x) % BASE;
		}
		x = (x * 1LL * x) % BASE;
		y /= 2;
	}              
	return res;
}

long long C(long long n, long long k) {
	if (k > n) return 0;
	long long res = 1;
	for (long long i = n - k + 1; i <= n; i++) res = mul(res, i);
	res = mul(res, rev[k]);
	return res;
}

vector<int> a;

long long calc(long long n, vector<int> a) {
	long long res = 1;
	int sum = 0;
	for (int i = 0; i < (int)a.size(); i++) sum += a[i];
	
	//cerr << n << " " << sum << endl;
	if (n < sum) return 0;

	for (int i = 0; i < sum; i++) res = mul(res, n - i);
	for (int i = 0; i < (int)a.size(); i++) res = mul(res, rev[a[i]]);
	return res;
}

int main() {
	freopen("input.txt", "r", stdin);
	scanf("%d%d", &n, &m);
	long long l = n * 1LL * n;
	rev[0] = 1;
	for (int i = 1; i < N; i++) rev[i] = mul(rev[i - 1], pw(i, BASE - 2));

	int sum = 0;
	a.resize(m);
	for (int i = 0; i < m; i++) {
	 	cin >> a[i];
	 	sum += a[i];
	}

	long long res = calc(1LL * n * n, a);
	{
	 	int sum1 = 0;
	 	vector<int> b;
	 	for (int i = 0; i < m; i++) {
	 	 	sum1 += a[i] % 2;
	 	 	b.push_back(a[i] / 2);
	 	}
	 	if (sum1 <= n % 2) res += calc(1LL * n * n / 2, b);
	}	

	{
	 	int sum1 = 0;
	 	vector<int> b;
	 	for (int i = 0; i < m; i++) {
	 	 	sum1 += a[i] % 4;
	 	 	b.push_back(a[i] / 4);
	 	}
	 	if (sum1 <= n % 2) res += 2 * calc(1LL * n * n / 4, b);
	}	
	res %= BASE;

        cout << mul(res, pw(4, BASE - 2)) << endl;

	return 0;
}
