#if 1
#include <iostream>
#include <cstring>
#include <cassert>
using namespace std;
typedef long long li;
const int maxn = 1e6, module = 1e9 + 9;
li D[maxn][2], sum[maxn];

int solve(int n, int m)
{
	if(n == 0) return 1;
	memset(D, 0, sizeof(D));
	memset(sum, 0, sizeof(sum));
	D[0][0] = 0;
	sum[0] = D[0][1] = 1;
	for (int i = 1; i < n; ++i)
	{
		//case * m
		D[i][1] = (D[i-1][0] + D[i-1][1]) % module;
		sum[i] = (sum[i-1] + D[i][1]) % module;

		//case - 1
		D[i][0] = sum[i-1] - (i >= m ? sum[i - m] : 0);
		while(D[i][0] < 0) D[i][0] += module;
	}
	return (D[n-1][0] + D[n-1][1]) % module;
}

int rec(int depth, int cnt, int n, int m)
{
	if(cnt == m) return 0;
	if(depth == n) return 1;
	int v1 = rec(depth + 1, cnt + 1, n, m);
	int v2 = rec(depth + 1, 0, n, m);
	return (v1 + v2) % module;
}

int slowsolve(int n, int m)
{
	if(n == 0) return 1;
	return rec(1, 0, n, m);
}

int main()
{
	cin.sync_with_stdio(false);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int n, m; cin >> m >> n;
	int a2 = slowsolve(n, m);
	cout << a2 << endl;
	/*
	for (int i = 0; i < 100; ++i)
	{
		m = 2 + rand() % 20;
		n = rand() % 20;
		int a1 = solve(n, m);
		int a2 = slowsolve(n, m);
		if(a1 != a2)
		{
			cout << a1 << ' ' << a2 << endl;
		}
	}
	*/
	return 0;
}
#endif